/*
 * This file is part of the YSSDWebImage package.
 * (c) Olivier Poitrey <rs@dailymotion.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

#import "YSSDWebImageCacheSerializer.h"

@interface YSSDWebImageCacheSerializer ()

@property (nonatomic, copy, nonnull) YSSDWebImageCacheSerializerBlock block;

@end

@implementation YSSDWebImageCacheSerializer

- (instancetype)initWithBlock:(YSSDWebImageCacheSerializerBlock)block {
    self = [super init];
    if (self) {
        self.block = block;
    }
    return self;
}

+ (instancetype)cacheSerializerWithBlock:(YSSDWebImageCacheSerializerBlock)block {
    YSSDWebImageCacheSerializer *cacheSerializer = [[YSSDWebImageCacheSerializer alloc] initWithBlock:block];
    return cacheSerializer;
}

- (NSData *)cacheDataWithImage:(UIImage *)image originalData:(NSData *)data imageURL:(nullable NSURL *)imageURL {
    if (!self.block) {
        return nil;
    }
    return self.block(image, data, imageURL);
}

@end
